require "defines"

normal_attack_sent_event = script.generate_event_name()
landing_attack_sent_event = script.generate_event_name()
remote.add_interface("freeplay",
{
  set_attack_data = function(data)
    global.attack_data = data
  end,

  get_attack_data = function()
    return global.attack_data
  end,

  get_normal_attack_sent_event = function()
    return normal_attack_sent_event
  end,
})

script.on_load(function()
    breakme()
end)

init_attack_data = function()
  global.attack_data = {
    -- whether all attacks are enabled
    enabled = true,
    -- this script is allowed to change the attack values attack_count and until_next_attack
    change_values = true,
    -- what distracts the creepers during the attack
    distraction = defines.distraction.byenemy,
    -- number of units in the next attack
    attack_count = 5,
    -- time to the next attack
    until_next_attack = 60 * 60 * 60,
  }
end

script.on_event(defines.events.on_player_created, function(event)
  local player = game.get_player(event.player_index)
  --player.force.logistic_robot_speed_modifier = 5
  player.force.research_all_technologies()
  
   player.insert{name="power-armor", count = 1}
         local p_armor = player.get_inventory(5)[1].grid
          p_armor.put({name = "fusion-reactor-equipment"})
          p_armor.put({name = "basic-exoskeleton-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "personal-roboport-equipment"})
				player.insert{name="construction-robot", count = 10}
				player.insert{name="blueprint", count = 3}
				player.insert{name="deconstruction-planner", count = 1}
        
  --[[for k, v in pairs (game.item_prototypes) do
  if v.place_result ~= nil then
  local c = v.stack_size
  if c % 2 == 0 then c = c/2 else 
  if c > 1 then c = c - 1 end end
  if v.name ~= "player-port" then
    player.insert{name = v.name, count = c}
  end ]]--
  --end

  if (#game.players <= 1) then
    game.show_message_dialog{text = {"msg-intro"}}
  end
end)

script.on_event(defines.events.on_built_entity, function(event)
  local p = game.get_player(event.player_index)
  local e = event.created_entity
  if e.name ~= "entity-ghost" then
  p.insert{name = e.name, count = 1}
end
  end)

script.on_event(defines.events.on_player_mined_item, function (event)
  local p = game.get_player(event.player_index)
  local i = event.item_stack
  p.remove_item{name = i.name, count = 1}
end)

function make_item_list()
if global.item_list == nil then 
     global.item_list = {}
      for k, v in pairs (game.item_prototypes) do    
        table.insert(global.item_list,v)
      end
      script.on_event(defines.events.on_tick, fill_chest)
    end
end
function make_item_chest()

local i = math.ceil(#global.item_list/48)
global.item_chest = {}
for k = 1,i do
global.item_chest[k] = game.surfaces["nauvis"].create_entity{name = "logistic-chest-storage", position = {k,-5}, force = game.forces.player}
global.item_chest[k].minable = false
global.item_chest[k].destructible = false
end
script.on_event(defines.events.on_tick, fill_chest)
end

function fill_chest()
for k, v in ipairs(global.item_list) do
if k % 60 == game.tick % 60 then
local i = math.ceil(k/48)
local l = k - ((i-1)*48)
global.item_chest[i].get_inventory(1)[l].set_stack{name = v.name, count = v.stack_size}
 end end
end


script.on_init(function()
  init_attack_data()
  make_item_list()
  make_item_chest()
end)

-- for backwards compatibility
script.on_configuration_changed(function(data)
  if global.attack_data == nil then
    init_attack_data()
    if global.attack_count ~= nil then global.attack_data.attack_count = global.attack_count end
    if global.until_next_attacknormal ~= nil then global.attack_data.until_next_attack = global.until_next_attacknormal end
  end
  if global.attack_data.distraction == nil then global.attack_data.distraction = defines.distraction.byenemy end
  
end)

script.on_event(defines.events.on_rocket_launched, function(event)
  local force = event.rocket.force
  if event.rocket.get_item_count("satellite") > 0 then
    if global.satellite_sent == nil then
      global.satellite_sent = {}
    end
    if global.satellite_sent[force.name] == nil then
      game.set_game_state{game_finished=true, player_won=true, can_continue=true}
      global.satellite_sent[force.name] = 1
    else
      global.satellite_sent[force.name] = global.satellite_sent[force.name] + 1
    end
    for index, player in pairs(force.players) do
      if player.gui.left.rocket_score == nil then
        local frame = player.gui.left.add{name = "rocket_score", type = "frame", direction = "horizontal", caption={"score"}}
        frame.add{name="rocket_count_label", type = "label", caption={"", {"rockets-sent"}, ""}}
        frame.add{name="rocket_count", type = "label", caption="1"}
      else
        player.gui.left.rocket_score.rocket_count.caption = tostring(global.satellite_sent[force.name])
      end
    end
  else
    if (#game.players <= 1) then
      game.show_message_dialog{text = {"gui-rocket-silo.rocket-launched-without-satellite"}}
    else
      for index, player in pairs(force.players) do
        player.print({"gui-rocket-silo.rocket-launched-without-satellite"})
      end
    end
  end
end)
